<template>
  <v-form
    ref="form"
    fast-fail
    validate-on="blur"
    @submit.prevent="submit()"
  >
    <v-text-field
      autofocus
      class="pb-2"
      label="Titre"
      :counter="64"
      :rules="[
        value => {
          if (value?.length > 0) return true
          return 'You need to give a title to your checklist.'
        },
        value => {
          if (value?.length < 64) return true
          return 'Checklist title length must be less than 64 characters.'
        },
      ]"
      variant="outlined"
      v-model="newChecklist.titre"
    ></v-text-field>
    <v-textarea
      class="pb-2"
      label="Description"
      variant="outlined"
      v-model="newChecklist.description"
    ></v-textarea>
    <div class="d-flex justify-end">
      <v-btn
        class="mr-2"
        type="submit"
        variant="flat"
        color="success"
        text="Create"
      ></v-btn>
      <v-btn
        variant="flat"
        color="grey"
        text="Cancel"
        @click="cancel()"
      ></v-btn>
    </div>
  </v-form>
</template>

<script>
export default {
  name: "checklist-form",
  data() {
    return {
      newChecklist: {
        titre: "",
        description: ""
      }
    }
  },
  methods: {
    async submit() {
      const { valid } = await this.$refs.form.validate()
      if (valid) {
        this.$emit('SUBMIT', this.newChecklist)
      }
    },
    cancel() {
      this.$refs.form.reset()
      this.$emit('CANCEL')
    }
  }
}
</script>

<style lang="scss" scoped>

</style>